;
; LOD Player Version 2
;
F1LO	= $FF0E
F1HI	= $FF12
F2LO	= $FF0F
F2HI	= $FF10

OFF	= $3F
	
; COMMAND BYTES

END_MARK	= $FE
SET_NOTE_ADD	= $FD
SET_VOLTAB	= $F0
SET_ARP		= $EF
SETINS		= $E0
SETLEN		= $40

; Constants
;base_note = -5 ; shift to F
C0	= base_note + 0
Ci0	= base_note + 1
D0	= base_note + 2
Di0	= base_note + 3
E0	= base_note + 4
F0	= base_note + 5
Fi0	= base_note + 6
G0	= base_note + 7
Gi0	= base_note + 8
A0	= base_note + 9
Ai0	= base_note + 10
B0	= base_note + 11

C1	= base_note + 12
Ci1	= base_note + 13
D1	= base_note + 14
Di1	= base_note + 15
E1	= base_note + 16
F1	= base_note + 17
Fi1	= base_note + 18
G1	= base_note + 19
Gi1	= base_note + 20
A1	= base_note + 21
Ai1	= base_note + 22
B1	= base_note + 23

C2	= base_note + 24
Ci2	= base_note + 25
D2	= base_note + 26
Di2	= base_note + 27
E2	= base_note + 28
F2	= base_note + 29
Fi2	= base_note + 30
G2	= base_note + 31
Gi2	= base_note + 32
A2	= base_note + 33
Ai2	= base_note + 34
B2	= base_note + 35

C3	= base_note + 36
Ci3	= base_note + 37
D3	= base_note + 38
Di3	= base_note + 39
E3	= base_note + 40
F3	= base_note + 41
Fi3	= base_note + 42
G3	= base_note + 43
Gi3	= base_note + 44
A3	= base_note + 45
Ai3	= base_note + 46
B3	= base_note + 47

C4	= base_note + 48
Ci4	= base_note + 49
D4	= base_note + 50
Di4	= base_note + 51
E4	= base_note + 52
F4	= base_note + 53
Fi4	= base_note + 54
G4	= base_note + 55
Gi4	= base_note + 56
A4	= base_note + 57
Ai4	= base_note + 58
B4	= base_note + 59

C5	= base_note + 60
Ci5	= base_note + 61
D5	= base_note + 62

;-----
          
	jmp PLAYER_INIT
PLAYER_CALL
	;jmp PLAYER
	rts
	dw PLAYER

PLAYER_INIT
	ldx #$60
	stx PLAYER_CALL		; disable the player call
	;         
	; *** Freq init
	;
	asl a
	tax
	lda Channels1,x
	sta PCH1_LO
	lda Channels1+1,x
	sta PCH1_HI
	;
	lda Channels2,x
	sta PCH2_LO
	lda Channels2+1,x
	sta PCH2_HI
	;
	lda Voltabs_lo,x
	sta voltab_lo_addr+1
	lda Voltabs_lo+1,x
	sta voltab_lo_addr+2
	;
	lda Voltabs_hi,x
	sta voltab_hi_addr+1
	lda Voltabs_hi+1,x
	sta voltab_hi_addr+2
	;
	lda Snares,x
	sta snare_addr_1+1
	sta snare_addr_2+1
	lda Snares+1,x
	sta snare_addr_1+2
	sta snare_addr_2+2
	;
	lda Hihats,x
	sta hihat_addr+1
	lda Hihats+1,x
	sta hihat_addr+2
	;
	ldx #$FF
	stx VOLTAB_CNT
	stx FRAME_CNT
	inx       
	stx NOTE1
	stx NOTE2
	stx ARP_CNT
	if EFFECTS = 1
	stx FX
	endif
	stx VOLUME
	stx note_add+1
	jsr res
	inx
	stx NOTELEN1
	stx NOTELEN2
	jsr res
	;
	ldx #$4C
	stx PLAYER_CALL
	rts
	;
res	ldy #$00
	db $2C
	
advance	ldy PCH1,x
	;      
	lda PCH1_LO,x
	sta PCH_TEMP
	lda PCH1_HI,x
	sta PCH_TEMP+1
	;
	lda (PCH_TEMP),y	; LO byte
	sta CH1_LO,x
	iny
	lda (PCH_TEMP),y	; HI byte
	beq res
	sta CH1_HI,x
	iny
	sty PCH1,x
ret1	rts
	
	;
	;##################
	;

PLAYER
	lda $FF07
	and #$40
	beq pal
	;
	ldx FRAME_CNT
	inx
	cpx #12			; count to 12 (6 frames * 2 calls)
	bne *+4
	ldx #$00
	stx FRAME_CNT
	cpx #10			; on NTSC, the last two calls (1 frame) do nothing
	bcs ret1
pal	;
	ldx #$01
channel_loop
	inc NOTE1,x
	;
	lda NOTE1,x
	cmp NOTELEN1,x
	beq next_note
	jmp channel_loop_end
	;
next_note 
	lda CH1_LO,x
	sta CH_TEMP
	lda CH1_HI,x
	sta CH_TEMP+1
	;
	ldy #$00
	sty NOTE1,x		; reset note counter
	;   
	lda (CH_TEMP),y		; get byte
	iny
	;
	cmp #END_MARK		; $FF goes to new pattern
	bne pl_10
	;
	jsr advance
	bne next_note		; should never be zero
	;
pl_10	
	cmp #SET_NOTE_ADD
	bne pl_16
	;
	lda (CH_TEMP),y
	sta note_add+1
	iny
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_16
	cmp #SET_VOLTAB
	bcc pl_12
	;
	sty pl_11+1		; save y
	and #$0F
	tay
voltab_lo_addr
	lda $FFFF,y
	sta VOL_TAB+1
voltab_hi_addr
	lda $FFFF,y
	sta VOL_TAB+2
	;
	lda #$FF
	sta VOLTAB_CNT
	;
pl_11	ldy #$00
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_12	
	cmp #SET_ARP		; arpeggio set?
	bne pl_13
	;
	lda (CH_TEMP),y		; get arpeggio byte
	and #$0F
	sta arpeggio_data+0
	;
	lda (CH_TEMP),y		; get same byte again
	lsr a
	lsr a
	lsr a
	lsr a
	sta arpeggio_data+1
	;
	lda #$04
	sta INS_TYPE1,x   	; automatically switch to arp instrument
	;
	iny
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_13	
	cmp #SETINS		; instrument change?
	bcc pl_01
	;
	and #$0F		; keep lower 4 bits
	sta INS_TYPE1,x   	; store instrument type
	;
	cmp #$01
	beq pl_15
	cmp #$02
	bne pl_14
	;
pl_15	lda #$07		; for bassdrum and snare, also set length to 7 (fixed)
	sta NOTELEN1,x
	lda #$00
	beq pl_02
	;
pl_14	lda (CH_TEMP),y		; get byte
	iny
	;
pl_01	cmp #SETLEN		; set note length?
	bcc pl_02
	;
	;SEC			; we know carry is always set
	sbc #$40
	sta NOTELEN1,x
	;
	lda (CH_TEMP),y
	iny
	;
pl_02	; - store note!
	;
	cmp #OFF
	beq pl_03
	clc
note_add
	adc #$00
pl_03	sta TONE1,x
	;
	; --- advance pointer
	;
	tya
	clc
	adc CH1_LO,x
	sta CH1_LO,x
	bcc noi_1
	inc CH1_HI,x
noi_1	;
	;
	; -----------------------------------------------------------------
	;
channel_loop_end
	dex
	bmi pl_50
	jmp channel_loop
	;    
pl_50	
	;
	; --- SOUND PROCESSING
	;
PLAYER_SOUND
	lda #$20
	sta NOISE
	;
	; ---
	;
	ldx #$01		; channel 2
player_no_sound_1
	jsr sound
	;
	sta F1LO_store+1
	sty F1HI_store+1
	;
	ldx #$00		; channel 1
player_no_sound_2
	jsr sound
	sta F2LO_store+1
	sty F2HI_store+1
	;
	; ---
	;
	ldy VOLTAB_CNT
	iny
res_v	
VOL_TAB
	lda $FFFF,y
	bpl noi_v		; check for end marker ($80 and higher)
	and #$7F
	tay
	jmp res_v
	;
noi_v	sty VOLTAB_CNT
player_no_sound_3
	clc
	adc VOLUME
	tay
	lda volume_map,y
	ora NOISE
	sta FF11_store+1
	;
	; ---
	;
	if EFFECTS = 1
	lda FX
	beq no_fx
	;
	jsr handle_effects
	endif
	;
no_fx
F1LO_store
	lda #$00
	sta F1LO
	lda F1HI
	and #$FC
F1HI_store
	ora #$00
	sta F1HI
F2LO_store
	lda #$00
	sta F2LO
F2HI_store
	lda #$00
	sta F2HI
	;
	; ---
	;
	lda F1LO
	cmp #$FE
	bne setvol		; not silent
	lda F2LO
	cmp #$FE
	beq sil			; silent: skip setting $FF11 to avoid clicks
	;
setvol	;
FF11_store
	lda #$00
player_channels
	and #$FF
	sta $FF11		; self-mod
	;
sil	rts     
	;
inst_table
	dw normal, bassdrum, snare, hihat, arpeggio, vibrato, normal, arp5, arpC, slidedown
	;
sound	lda TONE1,x
	cmp #OFF
	beq lookup
	;
	lda INS_TYPE1,x
	asl a
	tay
	lda inst_table,y
	sta inst_jump+1
	lda inst_table+1,y
	sta inst_jump+2
	;
inst_jump
	jmp $0000
	
	;
	; ---
	;
normal	lda TONE1,x		; normal note
lookup	tax
	lda freqs_lo,x
	ldy freqs_hi,x
	rts
	;
	; ---
	;
arp5	lda NOTE1,x
	and #$04
	beq normal
	;
	lda TONE1,x
	sec
	sbc #$05
	bne lookup
	;
arpC	lda NOTE1,x
	and #$04
	beq normal
	;cmp #$04
	;bcc normal
	;cmp #$08
	;bcs normal
	;
	lda TONE1,x
	clc
	adc #$0C
	bne lookup
	;
	; ---
	;
arpeggio
	lda ARP_CNT		; load current arp counter
	clc
	adc #$01
	cmp #$06		; auto reset every 6 frames (n1,n1,n2,n2,n3,n3)
	bne *+4
	lda #$00
	sta ARP_CNT
	lsr a
	tay
	lda arpeggio_data,y	; for channel 2 (self-mod)
	clc
	adc TONE1,x
	bne lookup
	;
	; ---
	;
vibrato	lda NOTE1,x
	and #$0F
	tay
	lda vibrato_data,y
	bmi vib_sub1
	;
vib_add
	sta vib2+1
	;
	lda TONE1,x
	tax
	ldy freqs_hi,x
	lda freqs_lo,x
	clc
vib2	adc #$01
	bcc *+3
	iny
	rts
	;
vib_sub1
	and #$7F
	;      
	sta vib4+1
	;
	lda TONE1,x
	tax
	ldy freqs_hi,x
	lda freqs_lo,x
	sec
vib4	sbc #$01
	bcs *+3
	dey
	rts
	;
	; ---
	;
hihat
	lda #$40
	sta NOISE
	lda NOTE1,x
	tax
hihat_addr
	lda hihat_freq,x
	ldy #$03
	rts
	;
	; ---
	;
snare	
	lda NOTE1,x
	asl a
	tax
	inx
snare_addr_1
	lda snare_data,x	; 16 bit add: add snare freq
	pha
	and #$60
	sta NOISE
	pla
	and #$03
	tay
	dex
snare_addr_2
	lda snare_data,x
	rts
	;
	; ---
	;
bassdrum
	lda NOTE1,x
	asl a
	tax
	lda bass_freq,x
	ldy bass_freq+1,x
	rts

slidedown
	txa
	asl a
	asl a
	clc
	adc NOTE1,x
	asl a
	sta sd1+1
	lda TONE1,x		; normal note
	tax
	ldy freqs_hi,x
	lda freqs_lo,x
	sec
sd1	sbc #$00
	bcs *+3
	dey
	rts

vibrato_data
	db $00,$01,$02,$03,$03,$03,$02,$01
	db $00,$81,$82,$83,$83,$83,$82,$81  

	if EFFECTS = 1
;beep: 9 frames loud, 5 frames quiet = 14 frames (28 calls)
;long beep: 28 frames loud, 5 frames quiet = 33 frames (66 calls)
thud
	ldy FX_CNT
	;
	cpx #$03
	bne *+4
	ldy #$20			; length
	;
	dey
	sty FX_CNT
	bne *+4
	sty FX
	;
	tya
	asl a
	sta F2LO_store+1
	sta F1LO_store+1
	lda #$02
	sta F2HI_store+1
	;
	tya
	and #$01
	sta F1HI_store+1
	;
	tya
	lsr a
	lsr a
	ora #$50
	sta FF11_store+1
	rts

handle_effects
	tax
	and #$7F
	tay
	ora #$80
	sta FX
	cpy #$01
	beq beep1
	cpy #$02
	beq beep2
	cpy #$03
	beq thud
	;
woosh
	ldy FX_CNT
	;
	cpx #$04
	bne *+4
	ldy #50				; length 
	;
	dey
	sty FX_CNT
	bne *+4
	sty FX
	;
	tya
	eor #$7F
	sta F2LO_store+1
	lda #$03
	sta F2HI_store+1
	;
	lda #$FE
	sta F1LO_store+1
	lda #$03
	sta F1HI_store+1
	;
	tya
	lsr a
	lsr a
	ora #$40
	sta FF11_store+1
	rts

beep1
	ldy FX_CNT
	;
	cpx #$01
	bne bp11
	;
	ldy #28
	;
bp11	dey
	sty FX_CNT
	bne bp12
	;
	sty FX
	;
bp12	lda #$58
	sta F2LO_store+1
	lda #$02
bp15	sta F2HI_store+1
	;
	lda #$FE
	sta F1LO_store+1
	lda #$03
	sta F1HI_store+1
	;
	lda FX_CNT
	cmp #10
	bcc bp13
	;
	lda #$05
	bne bp14
bp13	and #$0F
	lsr a
bp14	ora #$20
	sta FF11_store+1
	rts

beep2
	ldy FX_CNT
	;
	cpx #$02
	bne bp21
	;
	ldy #66
	;
bp21	dey
	sty FX_CNT
	bne bp22
	;
	sty FX
	;
bp22	tya
	and #$04
	beq bp25
	;
	lda #$96
	db $2C
	;
bp25	lda #$2C
	sta F2LO_store+1
	lda #$03
	;
	bne bp15
	endif
;[eof]