menu_text_src	= $80
menu_src	= $82
menu_dst	= $84
menu_dst_2	= $86
menu_selection	= $88
msg_width	= $89
msg_lo		= $8A
msg_hi		= $8B

menu_init
	;lda #menu_text_data & 255
	;sta menu_text_src
	;lda #menu_text_data >> 8
	;sta menu_text_src+1
	;
	lda #$00
	sta menu_selection
	;
	lda $FF07
	and #$40
	beq mi1
	;
	lda #60*2
	sta message_delay+1 
	;
mi1	rts

update_menu_line
	cmp menu_selection
	bne uml1
	;
	ldx #$73
	ldy #$D1
	bne uml2
	;
uml1	ldx #$74
	ldy #$11
	;
uml2	cmp curr_song_index
	bne uml3
	;
	pha
	txa
	and #$0F
	tax
	tya
	and #$F0
	tay
	pla
	;
uml3	stx m_color_1+1
	sty m_color_2+1
	jmp color_menu_line
	
highlight_menu_line
	ldx #$73
	ldy #$D1
	bne ml1
	
clear_menu_line
	ldx #$74
	ldy #$11
	;
ml1	lda menu_selection
	cmp curr_song_index
	bne ml3
	;
	txa
	and #$0F
	tax
	tya
	and #$F0
	tay
	;
ml3	stx m_color_1+1
	sty m_color_2+1
	;
	lda menu_selection
color_menu_line
	clc
	adc #MENU_Y
	tax
	inx
	lda mul40_lo,x
	clc
	adc #MENU_X
	sta menu_dst
	sta menu_dst_2
	lda mul40_hi,x
	ora #LUMMAP >> 8 
	sta menu_dst+1
	ora #$04
	sta menu_dst_2+1
	;
	ldy #MENU_WIDTH
ml2
m_color_1
	lda #$00
	sta (menu_dst),y
m_color_2
	lda #$00
	sta (menu_dst_2),y
	dey
	bne ml2
	;
	lda m_color_1+1
	and #$0F
	ora #$70
	sta (menu_dst),y
	;
	lda m_color_2+1
	and #$F0
	ora #$01
	sta (menu_dst_2),y 
	;
	rts
	
	; x = index
print_menu_line
	lda menu_line_pos_lo,x
	sta menu_dst
	lda menu_line_pos_hi,x
	sta menu_dst+1
	;
	lda menu_text_lo,x
	sta menu_text_src
	lda menu_text_hi,x
	sta menu_text_src+1
	;
	ldy #$00
pml2	lda (menu_text_src),y
	bmi pml1
	;
	sty pml3+1
	jsr write_1x1_char
pml3	ldy #$00
	iny
	bne pml2
	;
pml1	rts
	
;write_1x1_letter
;	ldy #$00
;w1l3	lda (menu_text_src),y
;	bpl w1l2
;	;
;	iny
;	lda (menu_text_src),y
;	sta menu_dst
;	iny
;	lda (menu_text_src),y
;	sta menu_dst+1
;	iny
;	bne w1l3
;	;
;w1l2	pha
;	;
;	iny
;	tya
;	clc
;	adc menu_text_src
;	sta menu_text_src
;	bcc *+4
;	inc menu_text_src+1
;	;
;	pla
	;
	; ---
	;
write_1x1_char
	sta menu_src
	lda #$00
	sta menu_src+1
	;
	asl menu_src
	rol menu_src+1
	asl menu_src
	rol menu_src+1
	asl menu_src
	rol menu_src+1
	;
	lda menu_src
	clc
	adc #font_1x1 & 255
	sta menu_src 
	lda menu_src+1
	adc #font_1x1 >> 8
	sta menu_src+1 
	;
	ldy #$00
	lda (menu_src),y
	sta (menu_dst),y
	iny
	lda (menu_src),y
	sta (menu_dst),y
	iny
	lda (menu_src),y
	sta (menu_dst),y
	iny
	lda (menu_src),y
	sta (menu_dst),y
	iny
	lda (menu_src),y
	sta (menu_dst),y
	iny
	lda (menu_src),y
	sta (menu_dst),y
	iny
	lda (menu_src),y
	sta (menu_dst),y		; copy only 7 rows, 8th row is always blank
	iny
	lda #$55
	sta (menu_dst),y
	;
	lda menu_dst
	clc
	adc #8
	sta menu_dst
	bcc *+4
	inc menu_dst+1
	;
	rts
	
clear_message	
	ldx #MSG_X
	ldy #MSG_Y
	;
	lda msg_width
	sta wwidth
	lda #0
	sta wheight
	;
	jsr restore_window
	;
	lda #$00
	sta msg_timer
	;
	rts

set_display_message
	sta msg_lo
	stx msg_hi
	rts

	; x = lo
	; a = hi
display_message
	lda msg_lo
	sta menu_text_src
	lda msg_hi
	sta menu_text_src+1
	;
	lda msg_timer
	beq dm0
	;
	jsr clear_message		; clear previous message
	;
dm0	ldy #$00
	lda (menu_text_src),y
	sta message_color_1+1
	iny
	lda (menu_text_src),y
	sta message_color_2+1
dm1	iny
	lda (menu_text_src),y
	bpl dm1
	dey
	dey
	dey
	sty wwidth
	sty msg_width			; also save to a separate variable
	;
	; ---
	;
	ldy #MSG_Y
	lda mul40_lo,y
	sta menu_dst
	sta menu_dst_2
	lda mul40_hi,y
	ora #LUMMAP >> 8 
	sta menu_dst+1
	ora #$04
	sta menu_dst_2+1
	;
	ldy msg_width
dm6	
message_color_1
	lda #$00
	sta (menu_dst),y
message_color_2
	lda #$00
	sta (menu_dst_2),y
	dey
	bpl dm6
	;
	; ---
	;
	ldy #MSG_Y			; get position
	lda mul320_lo,y
	clc
	adc #MSG_X * 8
	sta menu_dst
	lda mul320_hi,y
	sta menu_dst+1
	;
	ldy #$02
dm4	lda (menu_text_src),y		; write text
	bmi dm2
	sty dm3+1
	jsr write_1x1_char
dm3	ldy #$00
	iny
	bne dm4
	;
	; ---
	;
dm2	ldy #$02			; side shadow
	lda (menu_dst),y
	ora #$C0
	sta (menu_dst),y
	iny
	lda (menu_dst),y
	ora #$C0
	sta (menu_dst),y
	iny
	lda (menu_dst),y
	ora #$C0
	sta (menu_dst),y
	iny
	lda (menu_dst),y
	ora #$C0
	sta (menu_dst),y
	iny
	lda (menu_dst),y
	ora #$C0
	sta (menu_dst),y
	iny
	lda (menu_dst),y
	ora #$C0
	sta (menu_dst),y
	;
	ldy #MSG_Y+1			; get position of line below
	lda mul320_lo,y
	clc
	adc #MSG_X * 8
	sta menu_dst
	lda mul320_hi,y
	sta menu_dst+1
	;
	ldy #$00
	lda (menu_dst),y		; shadow left edge
	ora #$3F
	sta (menu_dst),y
	iny
	lda (menu_dst),y
	ora #$3F
	sta (menu_dst),y
	;
	ldx msg_width
	;
dm5	lda menu_dst
	clc
	adc #8
	sta menu_dst
	bcc *+4
	inc menu_dst+1
	;
	ldy #$00
	lda #$FF
	sta (menu_dst),y		; shadow below
	iny
	sta (menu_dst),y
	;
	dex
	bne dm5
	;
	ldy #8
	lda (menu_dst),y		; shadow bottom/right
	ora #$C0
	sta (menu_dst),y
	iny
	lda (menu_dst),y
	ora #$C0
	sta (menu_dst),y
	;
message_delay
	ldx #50*2
	stx msg_timer			; 2 seconds delay
	;
	lda #$00
	sta msg_lo
	sta msg_hi
	;
	rts

	include "font_1x1.asm"
	
	cmap " ",0
	cmap "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
	cmap "0",27,28,29,30,31,32,33,34,35,36
	cmap ".",37
	cmap ":",38

menu_text_1
	db "1. OVERWORLD",$FF
menu_text_2
	db "2. TITLE",$FF
menu_text_3
	db "3. TRANSMISSION",$FF
menu_text_4
	db "4. RACE START",$FF
menu_text_5
	db "5. TRACK 1",$FF
menu_text_6
	db "6. TRACK 2",$FF
menu_text_7
	db "7. TRACK 3",$FF
menu_text_8
	db "8. TRACK 4",$FF
menu_text_9
	db "9. INTERMISSION",$FF 
menu_text_10
	db "0. CONGRATS",$FF
	
menu_line_pos_lo
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 1) * 320) & 255
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 2) * 320) & 255
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 3) * 320) & 255
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 4) * 320) & 255
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 5) * 320) & 255
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 6) * 320) & 255
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 7) * 320) & 255
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 8) * 320) & 255
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 9) * 320) & 255
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 10) * 320) & 255

menu_line_pos_hi
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 1) * 320) >> 8
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 2) * 320) >> 8
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 3) * 320) >> 8
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 4) * 320) >> 8
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 5) * 320) >> 8
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 6) * 320) >> 8
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 7) * 320) >> 8
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 8) * 320) >> 8
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 9) * 320) >> 8
	db (pic + (MENU_X + 1) * 8 + (MENU_Y + 10) * 320) >> 8

menu_text_lo
	db menu_text_1 & 255
	db menu_text_2 & 255
	db menu_text_3 & 255
	db menu_text_4 & 255
	db menu_text_5 & 255
	db menu_text_6 & 255
	db menu_text_7 & 255
	db menu_text_8 & 255
	db menu_text_9 & 255
	db menu_text_10 & 255

menu_text_hi
	db menu_text_1 >> 8
	db menu_text_2 >> 8
	db menu_text_3 >> 8
	db menu_text_4 >> 8
	db menu_text_5 >> 8
	db menu_text_6 >> 8
	db menu_text_7 >> 8
	db menu_text_8 >> 8
	db menu_text_9 >> 8
	db menu_text_10 >> 8

msg_volume
	db $63,$DD
	db "VOLUME: "
volume_digit_1
	db "2"
volume_digit_2
	db "0"
	db $FF

msg_both_channels
	db $46,$77, "BOTH CHANNELS", $FF
msg_channel_1_only
	db $46,$77, "CHANNEL 1 ONLY", $FF
msg_channel_2_only
	db $46,$77, "CHANNEL 2 ONLY", $FF

msg_loop_off
	db $74,$51, "LOOP: OFF", $FF
msg_loop_on
	db $74,$51, "LOOP: ON", $FF

msg_menu_off
	db $74,$11, "MENU: OFF", $FF
msg_menu_on
	db $74,$11, "MENU: ON", $FF

msg_shuffle_off
	db $74,$41, "SHUFFLE: OFF", $FF
msg_shuffle_on
	db $74,$41, "SHUFFLE: ON", $FF

msg_paused
	db $74,$21, "PAUSED", $FF
	cmap
;eof