	org $1001-2
	dw  $1001
	
	include "!playerv.asm"
	
SCROLL_X		= 4
SCROLL_Y		= 22

MENU_X			= 23
MENU_Y			= 7
MENU_WIDTH		= 16
MENU_HEIGHT		= 12

MSG_X			= 0
MSG_Y			= 20

TIMER_X			= 32
TIMER_Y			= 20

SONGS			= 10

; keyboard
keyb_ptr		= $02		; 16 bit
keyb_lastkey		= $04
keyb_repeatcnt		= $05
keyb_shift		= $06
keyb_repeat_init	= 20		; constant
keyb_repeat		= 4		; constant

save_a			= $0D
save_x			= $0E
save_y			= $0F

text_gfx_ptr_1		= $10
text_gfx_ptr_2		= $12
text_gfx_ptr_3		= $14

text_sh_ptr_1		= $16
text_sh_ptr_2		= $18
text_sh_ptr_3		= $1A

text_buffer_dst		= $1E

char_src		= $20
char_sh1_src		= $22
char_sh2_src		= $24
txt_ptr			= $26

current_char		= $30	; current character (letter) in the scrolltext
current_col		= $31	; column index, starting from 0
scroll_tick		= $32	; 0 = no shift, 1 = shifted by 4 pixels
tmp			= $33
fill_ptr		= $34

music_box_src		= $40	; small "music box" text
music_box_dst		= $42
music_box_cnt		= $44

msg_timer		= $50
channels		= $51
timer_showing		= $52
curr_volume		= $53
curr_song_index		= $54
next_song_index		= $55
voldown_on		= $56	; non-zero: switching songs
scroll_hidden		= $57
scroll_hide_cnt		= $58
loop_on			= $59
shuffle_on		= $5A
shuffle_index		= $5B
menu_on			= $5C	; non-zero: menu is visible
menu_anim_cnt		= $5D
screen_off		= $5E
paused			= $5F

reveal_data_src		= $90
reveal_lum_src		= $92
reveal_lum_dst		= $94
reveal_col_src		= $96
reveal_col_dst		= $98
reveal_bitmap_src	= $9A
reveal_bitmap_dst	= $9C

	dw nextln,0	; second word is line number
	db $9E,"4109",0
nextln	db 0,0

start
	sei
	sta $ff3f
	;
	ldx #$FF
	lda $FF07
	and #$40
	beq *+4
	ldx #$F7
	cpx $FF1D
	bne *-3
	;
	lda #$0B				; screen off during init
	sta $FF06
	;
	lda #$53
	sta $FF19				; switch background color out of frame
	;
	lda $FF07				; PAL/NTSC friendly
	and #$40
	ora #$18				; multicolor
	sta $FF07
	;
	lda $FF12
	and #$03				; keep lowest 2 bits (sound)	
	ora #(pic) >> 10			; $08 = $2000, $10 = $4000, etc.
	sta $FF12
	;
	lda #(pic + $2000) >> 8			; set color map
	sta $FF14
	;
	lda #$00				; multicolor * background
	sta $FF16
	lda #$42
	sta $FF15
	;
	; ---
	;
	lda $FF07
	and #$40
	beq pal1
	;
	lda #$18				; bitmap scroll is narrower on NTSC
	sta scroll_start_col_1+1
	sta scroll_start_col_2+1
	lda #$E8
	sta scroll_end_col_1+1
	sta scroll_end_col_2+1
pal1	;
	;
	; ---
	;
	lda #line_buffer_1 & 255
	sta text_gfx_ptr_1
	lda #line_buffer_1 >> 8
	sta text_gfx_ptr_1+1
	;
	lda #line_buffer_2 & 255
	sta text_gfx_ptr_2
	lda #line_buffer_2 >> 8
	sta text_gfx_ptr_2+1
	;
	lda #line_buffer_3 & 255
	sta text_gfx_ptr_3
	lda #line_buffer_3 >> 8
	sta text_gfx_ptr_3+1
	;
	; ---
	;
	lda #shifted_line_buffer_1 & 255
	sta text_sh_ptr_1
	lda #shifted_line_buffer_1 >> 8
	sta text_sh_ptr_1+1
	;
	lda #shifted_line_buffer_2 & 255
	sta text_sh_ptr_2
	lda #shifted_line_buffer_2 >> 8
	sta text_sh_ptr_2+1
	;
	lda #shifted_line_buffer_3 & 255
	sta text_sh_ptr_3
	lda #shifted_line_buffer_3 >> 8
	sta text_sh_ptr_3+1
	;
	; ---
	;
	lda #$07
	sta text_buffer_dst
	;
	; --- init text
	;
	lda #text_data & 255
	sta txt_ptr
	lda #text_data >> 8
	sta txt_ptr+1
	;
	ldx #0
	stx current_char
	stx current_col
	inx
	stx scroll_tick
	;
	jsr menu_init
	;
	lda #$00
	sta msg_timer
	sta channels
	sta timer_showing
	sta curr_volume
	sta voldown_on
	sta scroll_hidden
	sta scroll_hide_cnt
	sta loop_on
	sta shuffle_on
	sta menu_on
	sta menu_anim_cnt
	sta screen_off
	sta paused
	;
	lda #$20
	sta music_box_cnt
	;
	lda #reveal_data & 255
	sta reveal_data_src
	lda #reveal_data >> 8
	sta reveal_data_src+1
	;
	ldx #$1F
	ldy #pic >> 8
	lda #$55
	jsr fill
	ldx #$03
	ldy #(pic + $2000) >> 8
	lda #$05
	jsr fill
	ldx #$03
	ldy #(pic + $2400) >> 8
	lda #$30
	jsr fill
	;         
	; ---
	;
	lda #$00
	sta curr_song_index
	sta next_song_index
	jsr song_init
	;
	lda #irq1 & 255
	sta $FFFE
	lda #irq1 >> 8
	sta $FFFF
	lda #$02
	sta $FF0B
	asl $FF09
	;
	lda #$CC
	cmp $FF1D
	bne *-3
	;
	lda #$3B				; turn graphics mode on
	sta $FF06
	;
	cli
	;
rev_loop
	lda #$CB
	cmp $FF1D
	bne *-3
	;
rv2	ldy #$00				; get 2 bytes
	lda (reveal_data_src),y
	sta reveal_lum_src
	sta reveal_lum_dst
	sta reveal_col_src
	sta reveal_col_dst
	sta reveal_bitmap_dst
	iny
	lda (reveal_data_src),y
	tax					; save high byte for later
	and #$03
	sta reveal_bitmap_dst+1
	ora #(pic + $2000) >> 8
	sta reveal_lum_dst+1
	ora #$04
	sta reveal_col_dst+1 
	clc
	adc #$24
	sta reveal_lum_src+1
	ora #$04
	sta reveal_col_src+1
	;
	dey					; y=0
	lda (reveal_lum_src),y			; copy lum
	sta (reveal_lum_dst),y
	lda (reveal_col_src),y			; copy color
	sta (reveal_col_dst),y
	;
	asl reveal_bitmap_dst			; 16 bit *8
	rol reveal_bitmap_dst+1
	asl reveal_bitmap_dst
	rol reveal_bitmap_dst+1
	asl reveal_bitmap_dst
	rol reveal_bitmap_dst+1
	;
	lda reveal_bitmap_dst+1
	clc
	adc #pic >> 8
	sta reveal_bitmap_dst+1
	;
	lda reveal_bitmap_dst
	sta reveal_bitmap_src
	lda reveal_bitmap_dst+1
	clc
	adc #$28
	sta reveal_bitmap_src+1
	;
	lda (reveal_bitmap_src),y		; copy bitmap
	sta (reveal_bitmap_dst),y
	iny
	lda (reveal_bitmap_src),y
	sta (reveal_bitmap_dst),y
	iny
	lda (reveal_bitmap_src),y
	sta (reveal_bitmap_dst),y
	iny
	lda (reveal_bitmap_src),y
	sta (reveal_bitmap_dst),y
	iny
	lda (reveal_bitmap_src),y
	sta (reveal_bitmap_dst),y
	iny
	lda (reveal_bitmap_src),y
	sta (reveal_bitmap_dst),y
	iny
	lda (reveal_bitmap_src),y
	sta (reveal_bitmap_dst),y
	iny
	lda (reveal_bitmap_src),y
	sta (reveal_bitmap_dst),y
	;
	lda reveal_data_src			; move source pointer ahead by 2 bytes
	clc
	adc #$02
	sta reveal_data_src
	bcc *+4
	inc reveal_data_src+1
	;
	txa
	and #$C0
	cmp #$C0
	beq rv4
	cmp #$80
	beq rv3
	jmp rv2
	;
rv3	jmp rev_loop
rv4	;					; done, continue
	;
;	lda #$CB
;	cmp $FF1D
;	bne *-3
;	dec $FF19
;	jsr draw_window_1
;	inc $FF19
;	lda #$CB
;	cmp $FF1D
;	bne *-3
;	dec $FF19
;	jsr draw_window_2
;	inc $FF19
;	lda #$CB
;	cmp $FF1D
;	bne *-3
;	dec $FF19
;	jsr draw_window_3
;	inc $FF19
;	lda #$CB
;	cmp $FF1D
;	bne *-3
;	dec $FF19
;	jsr draw_window_4
;	inc $FF19
;	;
;	lda #$CB
;	cmp $FF1D
;	bne *-3
;	dec $FF19
;	jsr draw_window_5
;	inc $FF19
	;
;	lda #$CA
;	cmp $FF1D
;	bne *-3  
;	dec $FF19
;	jsr restore_window_5
;	inc $FF19
;	lda #$CA
;	cmp $FF1D
;	bne *-3  
;	dec $FF19
;	jsr restore_window_4
;	inc $FF19
;	lda #$CA
;	cmp $FF1D
;	bne *-3  
;	dec $FF19
;	jsr restore_window_3
;	inc $FF19
;	lda #$CA
;	cmp $FF1D
;	bne *-3  
;	dec $FF19
;	jsr restore_window_2
;	inc $FF19
;	lda #$CA
;	cmp $FF1D
;	bne *-3  
;	dec $FF19
;	jsr restore_window_1
;	inc $FF19
	;
;	ldx #92
;xx1	jsr write_1x1_letter
;	dex
;	bpl xx1
;	;
;	jsr highlight_menu_line
	;
main_loop
	lda #key_table & 255
	ldx #key_table >> 8
	jmp keyboard
        
	include "window.asm"
	include "menu.asm"

	include "key_constants.asm"
	include "keyboard.asm"
	
fill	
	sty fill_ptr+1
	ldy #$00
	sty fill_ptr
fill1	sta (fill_ptr),y
	iny
	bne fill1
	inc fill_ptr+1
	dex
	bpl fill1
	rts 
	
switch_music_1
	lda #$00
	db $2C
switch_music_2
	lda #$01
	db $2C  
switch_music_3
	lda #$02
	db $2C
switch_music_4
	lda #$03
	db $2C
switch_music_5
	lda #$04
	db $2C
switch_music_6
	lda #$05
	db $2C
switch_music_7
	lda #$06
	db $2C
switch_music_8
	lda #$07
	db $2C
switch_music_9
	lda #$08
	db $2C
switch_music_10
	lda #$09
	;
	cmp curr_song_index			; if it's the same as the current song
	beq sm1					; do nothing
	;
	sta next_song_index
	lda #$01
	sta voldown_on
	;
sm1	jmp main_loop
	
time
	db 0,0,0,0,0,0,0
time_end
	db $0A,$0A,$06,$0A,$06,$0A

song_lengths
	db 0,0, 0,0, 2,2, 0,0			; hours : minutes : seconds (2 bytes unused)
	db 0,0, 0,2, 1,0, 0,0
	db 0,0, 0,0, 3,9, 0,0
	db 0,0, 0,0, 0,3, 0,0
	db 0,0, 0,1, 2,4, 0,0
	db 0,0, 0,1, 1,8, 0,0
	db 0,0, 0,2, 1,1, 0,0
	db 0,0, 0,2, 4,2, 0,0
	db 0,0, 0,0, 1,4, 0,0
	db 0,0, 0,0, 3,9, 0,0
	
reset_timer
	lda #0
	ldx #6
rt1	sta time,x
	dex
	bpl rt1
	rts 

inc_timer
	lda time+6
	clc
	adc #$01
timer_fine_counter
	cmp #50					; 50 on PAL, 60 on NTSC
	bne inc1
	;
	ldx #6
inc2	dex
	bmi inc4
	lda time,x
	clc
	adc #$01
	cmp time_end,x
	bne inc3
	lda #0
inc3	sta time,x
	beq inc2
	;
inc4	lda #$00
inc1	sta time+6
	;
	rts

display_timer
	lda #(pic + TIMER_X * 8 + TIMER_Y * 320) & 255
	sta menu_dst
	lda #(pic + TIMER_X * 8 + TIMER_Y * 320) >> 8
	sta menu_dst+1
	;
	lda time + 0
	ora time + 1
	bne dt1
	;
	lda #0
	jsr write_1x1_char
	lda #0
	jsr write_1x1_char
	lda #0
	jsr write_1x1_char
	jmp dt2
	;
dt1	lda time + 0
	clc
	adc #27
	jsr write_1x1_char
	;
	lda time + 1
	clc
	adc #27
	jsr write_1x1_char
	;
	lda #38
	jsr write_1x1_char
	;
dt2	lda time + 2
	clc
	adc #27
	jsr write_1x1_char
	;
	lda time + 3
	clc
	adc #27
	jsr write_1x1_char
	;
	lda #38
	jsr write_1x1_char
	;
	lda time + 4
	clc
	adc #27
	jsr write_1x1_char
	;
	lda time + 5
	clc
	adc #27
	jsr write_1x1_char
	;
	rts

volume_up
	lda voldown_on
	bne vu1
	;
	lda VOLUME
	beq vol_at_max
	sec
	sbc #$09
	sta VOLUME
	sta curr_volume
	;
	; --- adjust the numbers in the message
	;
	ldx volume_digit_2
	inx
	cpx #37					; overflow?
	bcc vu2
	;
	inc volume_digit_1
	;
	ldx #27
vu2	stx volume_digit_2
	;
vol_at_max
	lda #msg_volume & 255
	ldx #msg_volume >> 8
	jsr set_display_message
	;
vu1	jmp main_loop

volume_down
	lda voldown_on
	bne vu1
	;
	lda VOLUME
	cmp #20*9
	beq vol_at_min
	clc
	adc #$09
	sta VOLUME
	sta curr_volume
	;
	; --- adjust the numbers in the message
	;
	ldx volume_digit_2
	dex
	cpx #27
	bcs vd3
	;
	dec volume_digit_1
	;
	ldx #36
vd3	stx volume_digit_2
	;
vol_at_min
	lda #msg_volume & 255
	ldx #msg_volume >> 8
	jsr set_display_message
	;
	jmp main_loop
	
	;
	; ---
	;
toggle_channels
	ldx channels
	inx
	cpx #3
	bne *+4
	ldx #$00
	stx channels
	;
	lda channel_and_values,x
	sta player_channels+1
	;
	lda msg_channel_lo,x
	pha
	lda msg_channel_hi,x
	tax
	pla
	jsr set_display_message
	;
	jmp main_loop

channel_and_values
	db $FF, $EF, $9F

msg_channel_lo
	db msg_both_channels & 255
	db msg_channel_1_only & 255
	db msg_channel_2_only & 255
msg_channel_hi
	db msg_both_channels >> 8
	db msg_channel_1_only >> 8
	db msg_channel_2_only >> 8

	;
	; ---
	;                           
toggle_loop
	lda loop_on
	and #$01
	eor #$01
	sta loop_on
	;
	tax
	lda msg_loop_lo,x
	pha
	lda msg_loop_hi,x
	tax
	pla
	jsr set_display_message
	;
	jmp main_loop

msg_loop_lo
	db msg_loop_off & 255
	db msg_loop_on & 255
msg_loop_hi
	db msg_loop_off >> 8
	db msg_loop_on >> 8
                           
	;
	; ---
	;                           
toggle_menu
	lda menu_anim_cnt			; when the menu is already animating
	bne tm1					; do nothing
	;
	lda menu_on
	and #$01
	eor #$01
	sta menu_on				; toggle state
	;
	tax
	lda msg_menu_lo,x
	pha
	lda msg_menu_hi,x
	tax
	pla
	jsr set_display_message			; display appropriate message
	;
	lda #$01				; start the animation
	sta menu_anim_cnt
	;
tm1	jmp main_loop

msg_menu_lo
	db msg_menu_off & 255
	db msg_menu_on & 255
msg_menu_hi
	db msg_menu_off >> 8
	db msg_menu_on >> 8
	
	;
	; ---
	;
toggle_pause
	lda paused
	and #$01
	eor #$01
	sta paused
	beq tp1
	;
	lda #$00				; when paused, immediately turn off volume
	sta $FF11
	;
	lda #msg_paused & 255
	ldx #msg_paused >> 8
	jsr set_display_message			; display message
	;
tp1	jmp main_loop

	;
	; ---
	;                           
toggle_shuffle
	lda shuffle_on
	and #$01
	eor #$01
	sta shuffle_on
	;
	tax
	lda msg_shuffle_lo,x
	pha
	lda msg_shuffle_hi,x
	tax
	pla
	jsr set_display_message
	;
	lda shuffle_on				; when off, skip re-ordering
	beq sf1
	;
	lda #SONGS				; swap indexes this many times
	sta tmp
	;
sf2	txa
	eor $FF00
	eor $FF1D
	and #$0F
	tax
	lda shuffle_16_to_10,x			; random index 1
	pha
	eor $FF00
	eor $FF1D
	and #$0F
	tax
	lda shuffle_16_to_10,x			; random index 2
	tay
	pla
	tax
	lda shuffle_order,x			; swap them
	pha
	lda shuffle_order,y
	sta shuffle_order,x
	pla
	sta shuffle_order,y
	;
	dec tmp
	bne sf2
	;
	; ---
	;
	ldx #$00				; reset the shuffle index
	lda shuffle_order			; in case the current song (or next)
	cmp curr_song_index			; is the same as what would come next in the shuffle order
	beq sf3
	cmp next_song_index
	bne sf4
	;
sf3	ldx #$01				; skip that one
sf4	stx shuffle_index
	;
sf1	jsr pick_next_song			; pick (new) next song
	;
	jmp main_loop

msg_shuffle_lo
	db msg_shuffle_off & 255
	db msg_shuffle_on & 255
msg_shuffle_hi
	db msg_shuffle_off >> 8
	db msg_shuffle_on >> 8
	
shuffle_16_to_10
	db 0,1,1,2, 2,3,3,4
	db 5,5,6,7, 7,8,9,9
shuffle_order
	db 0,1,2,3,4,5,6,7,8,9			; should be same number as the constant SONGS
	
	;
	; ---
	; 
toggle_timer
	lda timer_showing
	and #$01
	eor #$01
	sta timer_showing
	tax
	lda BIT_JSR,x
	sta display_timer_call
	;
	txa
	bne tt1
	;
	lda #(pic + TIMER_X * 8 + TIMER_Y * 320) & 255
	sta menu_dst
	lda #(pic + TIMER_X * 8 + TIMER_Y * 320) >> 8
	sta menu_dst+1
	;
	ldy #8*8-1
	lda #$55
tt2	sta (menu_dst),y
	dey
	bpl tt2
	;
tt1	jmp main_loop

BIT_JSR
	db $2C,$20

toggle_screen
	lda screen_off
	and #$01
	eor #$01
	sta screen_off
	;
	jmp main_loop

screen_on_off_values
	db $3B,$0B

	;
	; ---
	;	
toggle_scroll
	lda scroll_hide_cnt			; when scroll hide animation is going, do nothing
	bne ts1
	;
	lda scroll_hidden
	and #$01
	tax
	eor #$01
	sta scroll_hidden
	;
	lda BIT_JSR,x
	sta scroll_call
	;
	txa
	bne ts1
	;
	lda #$01				; when hidden, start hide animation
	sta scroll_hide_cnt
	;
ts1	jmp main_loop

vol_down
	lda voldown_on				; when 0, do nothing
	beq vd1
	;
	inc voldown_on				; otherwise use it as a delay
	lda voldown_on
	and #$03				; only every 4th frame
	bne vd1
	;
	lda VOLUME
	cmp #20*9
	bne vd2
	;
	; fully muted, switch songs
	;
song_init
	lda menu_on				; is the menu visible?
	beq si1					; no, skip updating it
	;
	lda curr_song_index
	ldx #$FF
	stx curr_song_index
	jsr update_menu_line			; clear selection from current song
	;
si1	lda next_song_index
	sta curr_song_index
	;
	lda menu_on				; is the menu visible?
	beq si2					; no, skip updating it
	;
	lda curr_song_index			; show current song playing
	jsr update_menu_line
	;
si2	lda curr_song_index
	jsr PLAYER_INIT
	;
	lda curr_volume				; reset volume to user selection
	sta VOLUME
	;
	jsr reset_timer
	lda #$00
	sta voldown_on
	;
	; --- pick next song
	;
pick_next_song
	lda shuffle_on
	beq no_suffle
	;
	ldx shuffle_index
sf6	lda shuffle_order,x			; pick the next one in the shuffle order
	cmp curr_song_index
	bne sf5
	;
	jsr shuffle_index_increment
	jmp sf6
	;
sf5	sta next_song_index
	;
shuffle_index_increment
	inx					; increment the shuffle index
	cpx #SONGS				; wrap at max number of songs
	bne *+4
	ldx #0
	stx shuffle_index
	rts
	;
no_suffle
	ldx curr_song_index
	inx
	cpx #SONGS				; wrap at max number of songs
	bne *+4
	ldx #0
	stx next_song_index
	rts
	;
vd2	clc
	adc #$09				; lower volume and we're done
	sta VOLUME
	;
vd1	rts

	;
	; ---
	;
check_song_end
	lda loop_on				; when loop is on, don't stop current song
	ora voldown_on				; if volume down is on, also do nothing
	bne cse1
	;
	lda curr_song_index
	asl a
	asl a
	asl a
	tax
	ldy #$00
cse3	lda song_lengths,x
	cmp time,y
	beq cse2
	bcs cse1
	;
	lda #$01
	sta voldown_on				; start voldown (end current song)
	;
cse2	inx
	iny
	cpy #6
	bne cse3
	;
cse1	rts
	
per_frame_tasks
	ldx screen_off
	lda screen_on_off_values,x
	sta $FF06
	;
	;dec $FF19
	jsr write_music_box
	;inc $FF19
	;
	lda paused
	bne no_fast_forward
	;
	lda #$FB
	sta $FD30
	sta $FF08
	lda $FF08
	and #$20				; Query keyboard for "f"
	bne no_fast_forward			; not pressed
	;
	;dec $FF19
	lda #$2C
	sta player_no_sound_1			; disable sound processing
	sta player_no_sound_2
	lda #$60
	sta player_no_sound_3
	;
	jsr PLAYER				; fast forward (4x speed)
	jsr PLAYER
	jsr inc_timer
	jsr PLAYER
	jsr PLAYER
	jsr inc_timer
	jsr PLAYER
	;
	lda #$20				; enable sound processing
	sta player_no_sound_1			; before final call
	sta player_no_sound_2
	lda #$18
	sta player_no_sound_3
	;
	jsr PLAYER
	jsr inc_timer
	;inc $FF19
	;
no_fast_forward
	;
	jsr vol_down
	jsr check_song_end
	jsr auto_hide_message
	jsr auto_display_message
	jsr animate_menu
	jsr hide_scroll
	;
display_timer_call
	bit display_timer
	;
	lda $FF1D				; the bitmap scroll is skipped when there wounldn't be enough CPU time to render it
	cmp #$CC
	bcc skip_scroll
	;dec $FF19
scroll_call
	jsr do_scroll
	;inc $FF19
skip_scroll
	;
	rts

auto_hide_message
	lda msg_timer
	beq ahm1
	;
	dec msg_timer
	bne ahm1
	;
	jsr clear_message			; restore background
	; 
ahm1	rts

auto_display_message
	lda msg_lo				; this is always done on the "next" frame
	ora msg_hi
	beq adm1
	;
	jsr display_message
	;
adm1	rts

animate_menu
	ldx menu_anim_cnt
	beq am1
	;
	lda menu_on
	beq am2
	;
	txa					; values $80 and higher print the lines one-by-one
	bpl am4
	;
	and #$7F
	tax
	jsr print_menu_line
	;
	ldx menu_anim_cnt
	inx
	cpx #$8A
	bne *+4
	ldx #$00
	stx menu_anim_cnt
	bne am1
	;
	lda curr_song_index			; after the final line has been printed,
	jsr update_menu_line			; show current selection
	jmp highlight_menu_line
	;
am4	lda menu_show_calls_lo,x
	sta anim_call+1
	lda menu_show_calls_hi,x
	sta anim_call+2
	;
	inx
	cpx #7
	bne *+4
	ldx #$80
	stx menu_anim_cnt
	bne anim_call
	;
am2	lda menu_hide_calls_lo,x
	sta anim_call+1
	lda menu_hide_calls_hi,x
	sta anim_call+2
	;
am3	inx
	cpx #7
	bne *+4
	ldx #$00
	stx menu_anim_cnt
	;
anim_call
	jsr $FFFF
	;
am1	rts

menu_show_calls_lo
	db 0
	db draw_window_1 & 255
	db draw_window_2 & 255
	db draw_window_3 & 255
	db draw_window_4 & 255
	db draw_window_5 & 255
	dw am1 & 255
menu_show_calls_hi
	db 0
	db draw_window_1 >> 8
	db draw_window_2 >> 8
	db draw_window_3 >> 8
	db draw_window_4 >> 8
	db draw_window_5 >> 8
	dw am1 >> 8

menu_hide_calls_lo
	db 0
	db restore_window_6 & 255
	db restore_window_5 & 255
	db restore_window_4 & 255
	db restore_window_3 & 255
	db restore_window_2 & 255
	db restore_window_1 & 255
menu_hide_calls_hi
	db 0
	db restore_window_6 >> 8
	db restore_window_5 >> 8
	db restore_window_4 >> 8
	db restore_window_3 >> 8
	db restore_window_2 >> 8
	db restore_window_1 >> 8

hide_scroll
	lda scroll_hide_cnt			; when the counter is on zero,
	beq hs1					; do nothing
	;
	clc
	adc #SCROLL_Y-1
	tay
	ldx #SCROLL_X				; load x,y
	jsr w_calc_pos				; calc post
	;
	lda w_bitmap_dst			; calc dest pos
	sta w_bitmap_src
	lda w_bitmap_dst+1
	clc
	adc #$28
	sta w_bitmap_src+1
	;
	ldy #$00
hs2	lda (w_bitmap_src),y
	sta (w_bitmap_dst),y
	iny
	bne hs2
	;
	ldx scroll_hide_cnt
	inx
	cpx #4
	bne *+4
	ldx #0
	stx scroll_hide_cnt
	; 
hs1	rts

	;
	; ---
	;
menu_up
	lda menu_on				; when menu is off, do nothing
	beq mu1
	;
	jsr clear_menu_line
	ldx menu_selection
	dex
	bpl *+4
	ldx #SONGS-1				; last item's index
	stx menu_selection
	jsr highlight_menu_line
	;
mu1	jmp main_loop

menu_down
	lda menu_on				; when menu is off, do nothing
	beq mu1
	;
	jsr clear_menu_line
	ldx menu_selection
	inx
	cpx #SONGS				; number of items in menu
	bcc *+4
	ldx #0
	stx menu_selection
	jsr highlight_menu_line
	jmp main_loop

menu_select
	lda menu_on				; when menu is off, do nothing
	beq mu1
	;
	lda menu_selection
	cmp curr_song_index			; already the current song?
	beq ms1  				; yes, do nothing
	;
	sta next_song_index
	lda #$01
	sta voldown_on
	;
ms1	jmp main_loop

write_music_box
	lda music_box_cnt
	and #$7C
	asl a
	sta wmb_offset+1
	clc
	adc #(pic + 8 * 320 + 7 * 8 + 2) & 255
	sta music_box_dst
	sta music_box_src
	lda #(pic + 8 * 320 + 7 * 8 + 2) >> 8
	sta music_box_dst+1
	clc
	adc #$28
	sta music_box_src+1
	;
	lda music_box_cnt
	bmi wmb3
	;
	cmp #$20
	bcs wmb2
	;
	and #$03
	tax
	lda wmb_bits,x
	sta wmb_bit+1
	;
	ldy #$00
wmb_offset
	ldx #$00
wmb1	lda music_box_bits,x
wmb_bit
	and #$00
	ora (music_box_dst),y
	sta (music_box_dst),y
	inx
	iny
	cpy #5
	bne wmb1
	;
wmb2	inc music_box_cnt
	;
	rts

wmb3	and #$7F
	cmp #$20
	bcs wmb6
	;
	lda music_box_cnt
	and #$03
	tax
	lda wmb_bits,x
	sta wmb_bit2+1
	eor #$FF
	sta wmb_bit3+1
	;
	ldy #$00
wmb4	lda (music_box_src),y
wmb_bit2
	and #$00
	sta wmb5+1
	lda (music_box_dst),y
wmb_bit3
	and #$00
wmb5	ora #$00
	sta (music_box_dst),y
	iny
	cpy #5
	bne wmb4
	;
wmb6	inc music_box_cnt
	;
	rts

wmb_bits
	db $C0,$30,$0C,$03
	
	; 64*8 m none
music_box_bits
	db $FF,$CC,$CC,$CC,$CC,$00,$00,$00
	db $CC,$CC,$CC,$CC,$CF,$00,$00,$00
	db $CF,$CC,$CF,$C0,$CF,$00,$00,$00
	db $CC,$0C,$CC,$CC,$CC,$00,$00,$00
	db $FC,$C0,$C0,$C0,$FC,$00,$00,$00
	db $3F,$33,$3C,$33,$3F,$00,$00,$00
	db $3F,$33,$33,$33,$3F,$00,$00,$00
	db $33,$33,$0C,$33,$33,$00,$00,$00

do_scroll
	lda scroll_tick
	eor #$01
	sta scroll_tick
	beq do_scroll_1
	jmp do_scroll_shifted

do_scroll_1
scroll_start_col_1
	ldy #$00
ds1	lda pic_backup + (SCROLL_Y + 0) * 320 + (SCROLL_X * 8),y
	ora (text_gfx_ptr_1),y
	sta pic + (SCROLL_Y + 0) * 320 + (SCROLL_X * 8),y
	;
	lda pic_backup + (SCROLL_Y + 1) * 320 + (SCROLL_X * 8),y
	ora (text_gfx_ptr_2),y
	sta pic + (SCROLL_Y + 1) * 320 + (SCROLL_X * 8),y
	;
	lda pic_backup + (SCROLL_Y + 2) * 320 + (SCROLL_X * 8),y
	ora (text_gfx_ptr_3),y
	sta pic + (SCROLL_Y + 2) * 320 + (SCROLL_X * 8),y
	;
	iny
scroll_end_col_1
	cpy #$00
	bne ds1
	;
	; ---
	;
cc06	ldy current_col
	bne cc04
	;
	lda current_char
	asl a
	tax
	;
	lda char_data_prts,x
	sta char_src
	lda char_data_prts+1,x
	sta char_src+1
	;
	lda shifted_char_data_prts,x
	sta char_sh1_src
	lda shifted_char_data_prts+1,x
	sta char_sh1_src+1
	;
	lda char_sh1_src
	clc
	adc #3*8
	sta char_sh2_src
	lda char_sh1_src+1
	adc #0
	sta char_sh2_src+1
	;
cc04	inc current_col
	tya
	ldx current_char
	cmp char_columns,x
	bne cc05
	;
	; --- get next char
	;
cc08	ldy #$00
	sty current_col
	lda (txt_ptr),y
	cmp #$FF
	bne cc07
	;
	lda #text_data & 255
	sta txt_ptr
	lda #text_data >> 8
	sta txt_ptr+1
	bne cc08
	;
cc07	sta current_char
	;
	inc txt_ptr
	bne *+4
	inc txt_ptr+1
	;
	bne cc06
	;
cc05	ldy #$07
	ldx text_buffer_dst
cc01	lda (char_src),y
	sta line_buffer_1,x
	sta line_buffer_1 + $0100,x
	dex
	dey
	bpl cc01
	;
	lda char_src
	clc
	adc #$08
	sta char_src
	bcc *+4
	inc char_src+1
	;
	ldy #$07
	ldx text_buffer_dst
cc02	lda (char_src),y
	sta line_buffer_2,x
	sta line_buffer_2 + $0100,x
	dex
	dey
	bpl cc02
	;
	lda char_src
	clc
	adc #$08
	sta char_src
	bcc *+4
	inc char_src+1
	;
	ldy #$07
	ldx text_buffer_dst
cc03	lda (char_src),y
	sta line_buffer_3,x
	sta line_buffer_3 + $0100,x
	dex
	dey
	bpl cc03
	;
	lda char_src
	clc
	adc #$08
	sta char_src
	bcc *+4
	inc char_src+1
	;
	; ---
	;    
	lda text_gfx_ptr_1
	clc
	adc #$08
	sta text_gfx_ptr_1
	sta text_gfx_ptr_2
	sta text_gfx_ptr_3
	;
	sta text_sh_ptr_1
	sta text_sh_ptr_2
	sta text_sh_ptr_3
	;
	lda text_buffer_dst
	clc
	adc #$08
	sta text_buffer_dst 
	rts

	;
	; ---
	;
do_scroll_shifted
scroll_start_col_2
	ldy #$00
ds2	lda pic_backup + (SCROLL_Y + 0) * 320 + (SCROLL_X * 8),y
	ora (text_sh_ptr_1),y
	sta pic + (SCROLL_Y + 0) * 320 + (SCROLL_X * 8),y
	;
	lda pic_backup + (SCROLL_Y + 1) * 320 + (SCROLL_X * 8),y
	ora (text_sh_ptr_2),y
	sta pic + (SCROLL_Y + 1) * 320 + (SCROLL_X * 8),y
	;
	lda pic_backup + (SCROLL_Y + 2) * 320 + (SCROLL_X * 8),y
	ora (text_sh_ptr_3),y
	sta pic + (SCROLL_Y + 2) * 320 + (SCROLL_X * 8),y
	;
	iny
scroll_end_col_2
	cpy #$00
	bne ds2
	;
	ldy #$07
	lda text_buffer_dst
	sec
	sbc #$08
	tax
sc01	lda shifted_line_buffer_1,x
	and #$F0
	sta tmp
	lda (char_sh1_src),y
	and #$0F
	ora tmp
	sta shifted_line_buffer_1,x
	sta shifted_line_buffer_1 + $0100,x
	dex
	dey
	bpl sc01
	;
	ldy #$07
	ldx text_buffer_dst
sc11	lda (char_sh2_src),y
	and #$F0
	sta shifted_line_buffer_1,x
	sta shifted_line_buffer_1 + $0100,x
	dex
	dey
	bpl sc11
	;
	lda char_sh1_src
	clc
	adc #$08
	sta char_sh1_src
	bcc *+4
	inc char_sh1_src+1
	;
	lda char_sh2_src
	clc
	adc #$08
	sta char_sh2_src
	bcc *+4
	inc char_sh2_src+1
	;
	ldy #$07
	lda text_buffer_dst
	sec
	sbc #$08
	tax
sc02	lda shifted_line_buffer_2,x
	and #$F0
	sta tmp
	lda (char_sh1_src),y
	and #$0F
	ora tmp
	sta shifted_line_buffer_2,x
	sta shifted_line_buffer_2 + $0100,x
	dex
	dey
	bpl sc02
	;
	ldy #$07
	ldx text_buffer_dst
sc12	lda (char_sh2_src),y
	and #$F0
	sta shifted_line_buffer_2,x
	sta shifted_line_buffer_2 + $0100,x
	dex
	dey
	bpl sc12
	;
	lda char_sh1_src
	clc
	adc #$08
	sta char_sh1_src
	bcc *+4
	inc char_sh1_src+1
	;
	lda char_sh2_src
	clc
	adc #$08
	sta char_sh2_src
	bcc *+4
	inc char_sh2_src+1
	;
	ldy #$07
	lda text_buffer_dst
	sec
	sbc #$08
	tax
sc03	lda shifted_line_buffer_3,x
	and #$F0
	sta tmp
	lda (char_sh1_src),y
	and #$0F
	ora tmp
	sta shifted_line_buffer_3,x
	sta shifted_line_buffer_3 + $0100,x
	dex
	dey
	bpl sc03
	;
	ldy #$07
	ldx text_buffer_dst
sc13	lda (char_sh2_src),y
	and #$F0
	sta shifted_line_buffer_3,x
	sta shifted_line_buffer_3 + $0100,x
	dex
	dey
	bpl sc13
	;
	lda char_sh1_src
	clc
	adc #$08
	sta char_sh1_src
	bcc *+4
	inc char_sh1_src+1
	;
	lda char_sh2_src
	clc
	adc #$08
	sta char_sh2_src
	bcc *+4
	inc char_sh2_src+1
	;
	rts

irq1	sta save_a
	stx save_x
	sty save_y
	;
	lda paused
	bne ps1
	;
	;dec $FF19
	jsr PLAYER
	;inc $FF19
ps1	;
	;
	lda #irq2 & 255
	sta $FFFE
	lda #irq2 >> 8
	sta $FFFF
	lda #$AA
	sta $FF0B
	;
	asl $FF09
	ldy save_y
	ldx save_x
	lda save_a
	rti

irq2	sta save_a
	stx save_x
	sty save_y
	;
	lda paused
	bne ps2
	;
	;dec $FF19
	jsr PLAYER
	jsr inc_timer
	;inc $FF19
ps2	;
	;
	lda #irq1 & 255
	sta $FFFE
	lda #irq1 >> 8
	sta $FFFF
	lda #$02
	sta $FF0B
	;
	asl $FF09
	ldy save_y
	ldx save_x
	lda save_a
	rti
	
	align 256
reveal_data
	include "reveal.asm"

	align 256
line_buffer_1
	ds 512
line_buffer_2
	ds 512
line_buffer_3
	ds 512
shifted_line_buffer_1
	ds 512
shifted_line_buffer_2
	ds 512
shifted_line_buffer_3
	ds 512

key_table
	dw per_frame_tasks
	;
	dw KEY_1, switch_music_1
	dw KEY_2, switch_music_2
	dw KEY_3, switch_music_3
	dw KEY_4, switch_music_4
	dw KEY_5, switch_music_5
	dw KEY_6, switch_music_6
	dw KEY_7, switch_music_7
	dw KEY_8, switch_music_8
	dw KEY_9, switch_music_9
	dw KEY_0, switch_music_10
	;
	dw KEY_CURSOR_UP, menu_up
	dw KEY_CURSOR_DOWN, menu_down
	dw KEY_SPACE, menu_select
	dw KEY_RETURN, menu_select
	;
	dw KEY_PLUS, volume_up
	dw KEY_MINUS, volume_down
	;
	dw KEY_C, toggle_channels
	dw KEY_L, toggle_loop
	dw KEY_M, toggle_menu
	dw KEY_P, toggle_pause
	dw KEY_S, toggle_shuffle
	dw KEY_T, toggle_timer
	dw KEY_W, toggle_scroll
	dw KEY_X, toggle_screen
	;
	dw 0

text_data
	cmap " ",0
	cmap "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
	cmap "0",15
	cmap "1",27,28,29,30,31,32,33,34,35
	cmap "!",36
	cmap "'",37
	cmap "(",38
	cmap ")",39
	cmap ",",40
	cmap "-",41
	cmap ".",42
	cmap ":",43
	db "WELCOME TO THE TURBO OUTRUN MUSIC BOX!"
	db "                     "
	db "IF YOU'RE FEELING ADVENTUROUS, "
	db "START PRESSING RANDOM BUTTONS! "
	db "OTHERWISE, A RUNDOWN OF ALL FEATURES WILL SHORTLY FOLLOW."
	db "                     "
	db "BUT FIRST, LET'S GET THE CREDITS OUT OF THE WAY: "
	db "ORIGINAL IMAGES BY ALMIGHTY GOD AND JONEGG (ON C64), "
	db "CONVERTED BY UNREAL. "
	db "EVERYTHING ELSE (MUSIC, PLAYER, DESIGN, CODE, FONTS AND ADDITION GRAPHICS) BY CSABO OF LOD. "
	db "ALL TUNES ARE COVERS, MOSTLY BASED ON JEROEN TEL'S, BUT ALSO ON THE ARCADE VERSIONS. "
	db "                     "
	db "ALL RIGHT, LET'S SEE WHAT WE CAN DO: "
	db "PRESS 1-0 TO IMMEDIATELY SELECT SONGS. "
	db "PRESS M TO TOGGLE THE TRACK LIST MENU, ONCE OPENED, USE CURSOR AND SPACE. "
	db "PRESS L TO TOGGLE LOOPING, AND S TO TOGGLE SHUFFLE. "
	db "USE PLUS AND MINUS TO ADJUST THE VOLUME. "
	db "YOU CAN FAST FORWARD THE CURRENT SONG BY PRESSING F, OR PAUSE IT WITH P. "
	db "IF YOU'RE CURIOUS, PRESS C TO TOGGLE WHICH CHANNELS ARE PLAYING. "
	db "PRESSING T WILL TOGGLE THE TIMER, W WILL TOGGLE THIS SCROLL, AND X WILL TOGGLE TURNING OFF THE SCREEN. "
	db "                     "
	db "GREETS TO ALL PLUS4 SCENERS! ENJOY! CSABO OUT. "
	db "                     "
	db $FF
	cmap
	
	;
	; ---
	;
	
RACE_START = 0
EFFECTS = 0
MBOX = 1
	include "!player.asm"
	
	;
	; ---
	;
	
	align $2000
pic
	;include "pic.asm"
	ds $2800
pic_backup
	include "pic.asm"

space
	ds 2 * 24
	
	include "charset.asm"
	
char_data_prts
	dw space
	dw charset + 0 * 24	; a
	dw charset + 2 * 24
	dw charset + 4 * 24
	dw charset + 6 * 24
	dw charset + 8 * 24
	dw charset + 10 * 24
	dw charset + 12 * 24
	dw charset + 14 * 24
	dw charset + 16 * 24	; i
	dw charset + 17 * 24
	dw charset + 19 * 24
	dw charset + 21 * 24
	dw charset + 23 * 24	; m
	dw charset + 26 * 24
	dw charset + 28 * 24
	dw charset + 30 * 24
	dw charset + 32 * 24
	dw charset + 34 * 24
	dw charset + 36 * 24
	dw charset + 38 * 24
	dw charset + 40 * 24
	dw charset + 42 * 24
	dw charset + 44 * 24	; w
	dw charset + 47 * 24
	dw charset + 49 * 24
	dw charset + 51 * 24
	;
	dw charset + 53 * 24
	dw charset + 55 * 24
	dw charset + 57 * 24
	dw charset + 59 * 24
	dw charset + 61 * 24
	dw charset + 63 * 24
	dw charset + 65 * 24
	dw charset + 67 * 24
	dw charset + 69 * 24
	;
	dw charset + 71 * 24	; !
	dw charset + 72 * 24
	dw charset + 73 * 24
	dw charset + 75 * 24
	dw charset + 77 * 24
	dw charset + 78 * 24
	dw charset + 80 * 24
	dw charset + 81 * 24

shifted_char_data_prts
	dw space
	dw charset_shifted + 0 * 24	; a
	dw charset_shifted + 2 * 24
	dw charset_shifted + 4 * 24
	dw charset_shifted + 6 * 24
	dw charset_shifted + 8 * 24
	dw charset_shifted + 10 * 24
	dw charset_shifted + 12 * 24
	dw charset_shifted + 14 * 24
	dw charset_shifted + 16 * 24	; i
	dw charset_shifted + 17 * 24
	dw charset_shifted + 19 * 24
	dw charset_shifted + 21 * 24
	dw charset_shifted + 23 * 24	; m
	dw charset_shifted + 26 * 24
	dw charset_shifted + 28 * 24
	dw charset_shifted + 30 * 24
	dw charset_shifted + 32 * 24
	dw charset_shifted + 34 * 24
	dw charset_shifted + 36 * 24
	dw charset_shifted + 38 * 24
	dw charset_shifted + 40 * 24
	dw charset_shifted + 42 * 24
	dw charset_shifted + 44 * 24	; w
	dw charset_shifted + 47 * 24
	dw charset_shifted + 49 * 24
	dw charset_shifted + 51 * 24
	;
	dw charset_shifted + 53 * 24
	dw charset_shifted + 55 * 24
	dw charset_shifted + 57 * 24
	dw charset_shifted + 59 * 24
	dw charset_shifted + 61 * 24
	dw charset_shifted + 63 * 24
	dw charset_shifted + 65 * 24
	dw charset_shifted + 67 * 24
	dw charset_shifted + 69 * 24
	;
	dw charset_shifted + 71 * 24
	dw charset_shifted + 72 * 24
	dw charset_shifted + 73 * 24
	dw charset_shifted + 75 * 24
	dw charset_shifted + 77 * 24
	dw charset_shifted + 78 * 24
	dw charset_shifted + 80 * 24
	dw charset_shifted + 81 * 24

char_columns
	db 1 ; space
	db 2,2,2,2,2,2,2,2
	db 1 ; "I"
	db 2,2,2
	db 3 ; "M"
	db 2,2,2,2,2,2,2,2,2
	db 3 ; "W"
	db 2,2,2
	;
	db 2,2,2,2,2,2,2,2,2 ; 1-9
	db 1 ; !
	db 1 ; '
	db 2,2 ; ()
	db 1 ; ,
	db 2 ; -
	db 1,1 ; .:

	include "!player_data.asm"
base_note = 0
	include "notes.asm"
	include "..\music_overworld.asm"	; 1
base_note = -10
	include "notes.asm"
	include "..\music_title.asm"		; 2
base_note = 0
	include "notes.asm"
	include "..\music_transmission.asm"	; 3
	include "..\music_track_1.asm"		; 4,5
base_note = -5
	include "notes.asm"
	include "..\music_track_2.asm"		; 6
base_note = 0
	include "notes.asm"
	include "..\music_track_3.asm"		; 7
	include "..\music_track_4.asm"		; 8
	include "..\music_intermission.asm"	; 9
base_note = -9
	include "notes.asm"
	include "..\music_congrats.asm"		; 10

Channels1
	dw Overworld_Channel1
	dw Title_Channel1 
	dw Transmission_Channel1
	dw Race_Start_Channel1
	dw Track1_Channel1
	dw Track2_Channel1
	dw Track3_Channel1
	dw Track4_Channel1
	dw Intermission_Channel1
	dw Congrats_Channel1
Channels2
	dw Overworld_Channel2 
	dw Title_Channel2
	dw Transmission_Channel2
	dw Race_Start_Channel2
	dw Track1_Channel2
	dw Track2_Channel2
	dw Track3_Channel2
	dw Track4_Channel2
	dw Intermission_Channel2
	dw Congrats_Channel2
Voltabs_lo
	dw Overworld_voltab_lo
	dw Title_voltab_lo
	dw Transmission_voltab_lo
	dw Track1_voltab_lo
	dw Track1_voltab_lo
	dw Track2_voltab_lo
	dw Track3_voltab_lo
	dw Track4_voltab_lo
	dw Intermission_voltab_lo
	dw Congrats_voltab_lo
Voltabs_hi
	dw Overworld_voltab_hi 
	dw Title_voltab_hi
	dw Transmission_voltab_hi
	dw Track1_voltab_hi
	dw Track1_voltab_hi
	dw Track2_voltab_hi
	dw Track3_voltab_hi
	dw Track4_voltab_hi
	dw Intermission_voltab_hi
	dw Congrats_voltab_hi
Snares
	dw Overworld_snare_data
	dw Title_snare_data
	dw snare_data
	dw snare_data
	dw snare_data
	dw snare_data
	dw snare_data
	dw Track4_snare_data
	dw snare_data
	dw snare_data
Hihats
	dw hihat_freq
	dw hihat_freq
	dw hihat_freq
	dw hihat_freq
	dw hihat_freq
	dw hihat_freq
	dw Track3_hihat_freq
	dw hihat_freq
	dw hihat_freq
	dw hihat_freq
;eof