BITMAP = pic
LUMMAP = pic + $2000
COLMAP = LUMMAP + $0400

wwidth		= $60
wheight		= $61    
w_max_y		= $62
w_bitmap_src	= $64
w_bitmap_dst	= $66
w_line_add	= $68
w_lum_src	= $70
w_lum_dst	= $72
w_col_src	= $74
w_col_dst	= $76

w_copy_char_same_byte	macro b
	ldy #$00
	lda #b
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	endm

w_copy_char_top	macro b1, b2
	ldy #$00
	lda #b1
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	lda #b2
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	endm

w_copy_char_bottom	macro b1, b2
	ldy #$00
	lda #b1
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	iny
	lda #b2
	sta (w_bitmap_dst),y
	iny
	sta (w_bitmap_dst),y
	endm

w_add_8	macro
	lda w_bitmap_dst
	clc
	adc #8
	sta w_bitmap_dst
	bcc *+4
	inc w_bitmap_dst+1
	endm

w_add_line macro
	lda w_bitmap_dst
	clc
	adc w_line_add
	sta w_bitmap_dst
	lda w_bitmap_dst+1
	adc w_line_add+1
	sta w_bitmap_dst+1
	endm

w_add_line_src macro
	lda w_bitmap_src
	clc
	adc w_line_add
	sta w_bitmap_src
	lda w_bitmap_src+1
	adc w_line_add+1
	sta w_bitmap_src+1
	endm

draw_window_1
	ldx #MENU_X+4
	ldy #MENU_Y+4
	;
	lda #MENU_WIDTH-10
	sta wwidth
	lda #MENU_HEIGHT-10
	sta wheight
	;
	jmp draw_window

draw_window_2
	ldx #MENU_X+3
	ldy #MENU_Y+3
	;
	lda #MENU_WIDTH-8
	sta wwidth
	lda #MENU_HEIGHT-8
	sta wheight
	;
	jmp draw_window

draw_window_3
	ldx #MENU_X+2
	ldy #MENU_Y+2
	;
	lda #MENU_WIDTH-6
	sta wwidth
	lda #MENU_HEIGHT-6
	sta wheight
	;
	jmp draw_window_edge_only
	
draw_window_4
	ldx #MENU_X+1
	ldy #MENU_Y+1
	;
	lda #MENU_WIDTH-4
	sta wwidth
	lda #MENU_HEIGHT-4
	sta wheight
	;
	jmp draw_window_edge_only

draw_window_5
	ldx #MENU_X
	ldy #MENU_Y
	;
	lda #MENU_WIDTH-2
	sta wwidth
	lda #MENU_HEIGHT-2
	sta wheight
	;
	jmp draw_window_edge_only

	; x,y = position in chars
	; w,h = width, height
	;
draw_window
	jsr w_calc_pos
	;
	; ---
	;
	jsr w_color_window
	;
	; ---
	;
	jsr w_top_line
	;
	; ---
	;
	lda wheight
	beq dw15 
dw11	;
	jsr w_middle_full
	dec wheight
	bne dw11
	;
	; ---
	;
dw15	;
	jsr w_bottom_line
	rts

	; x,y = position in chars
	; w,h = width, height
	;
draw_window_edge_only
	jsr w_calc_pos
	lda wwidth
	asl a
	asl a
	asl a
	sta w_middle_add+1
	;
	; ---
	;
	jsr w_color_window
	;
	; ---
	;
	jsr w_top_line
	jsr w_middle_full
	;
	; ---
	;
	ldx wheight
	dex
	dex
dweo1	
	w_copy_char_same_byte $95
	w_add_8
	;
	w_copy_char_same_byte $55
	;
	lda w_bitmap_dst
	clc
w_middle_add
	adc #0
	sta w_bitmap_dst
	bcc *+4
	inc w_bitmap_dst+1
	;
	w_copy_char_same_byte $55
	w_add_8
	;
	w_copy_char_same_byte $57
	;
	w_add_line
	;
	dex
	beq dweo2
	jmp dweo1
	;
	; ---
	;
dweo2
	jsr w_middle_full
	jsr w_bottom_line
	rts

w_color_window
	ldx wheight
	inx
dw02	ldy wwidth
	iny
	iny
dw01	lda #$74
	sta (w_lum_dst),y			; set colors
	lda #$11
	sta (w_col_dst),y
	dey
	bpl dw01
	;
	lda w_lum_dst
	clc
	adc #40
	sta w_lum_dst
	sta w_col_dst
	bcc *+6
	inc w_lum_dst+1
	inc w_col_dst+1
	dex
	bpl dw02
	rts

w_top_line
	w_copy_char_top $AA,$95
	w_add_8
	;
	ldx wwidth
dw10	;
	w_copy_char_top $AA,$55
	w_add_8
	dex
	bpl dw10
	;
	w_copy_char_top $A9,$57
	;
	w_add_line
	rts
	
w_middle_full
	w_copy_char_same_byte $95
	w_add_8
	;
	ldx wwidth
dw12	ldy #$07
	lda #$55
dw13	sta (w_bitmap_dst),y
	dey
	bpl dw13
	w_add_8
	dex
	bpl dw12
	;
	w_copy_char_same_byte $57
	;
	w_add_line
	rts

w_bottom_line
	w_copy_char_bottom $95,$7F
	w_add_8
	;
	ldx wwidth
dw14	;
	w_copy_char_bottom $55,$FF
	w_add_8
	dex
	bpl dw14
	;
	w_copy_char_bottom $57,$FF
	rts

w_calc_pos
	txa
	sta w_bitmap_dst
	lda #$00
	sta w_bitmap_dst+1
	;
	asl w_bitmap_dst
	rol w_bitmap_dst+1
	asl w_bitmap_dst
	rol w_bitmap_dst+1
	asl w_bitmap_dst
	rol w_bitmap_dst+1
	;
	lda mul320_lo,y
	clc
	adc w_bitmap_dst
	sta w_bitmap_dst
	lda mul320_hi,y
	adc w_bitmap_dst+1
	sta w_bitmap_dst+1			; bitmap destination calculated
	;
	txa
	clc
	adc mul40_lo,y
	sta w_lum_dst
	sta w_col_dst
	lda mul40_hi,y
	ora #LUMMAP >> 8
	sta w_lum_dst+1
	ora #$04
	sta w_col_dst+1				; lum/col destination calculated
	;
	lda #38
	sec
	sbc wwidth
	sta w_line_add
	lda #$00
	sta w_line_add+1
	;
	asl w_line_add
	rol w_line_add+1
	asl w_line_add
	rol w_line_add+1
	asl w_line_add
	rol w_line_add+1
	;
	rts

;corner_top_left
;	db $AA,$AA,$95,$95,$95,$95,$95,$95
;edge_top
;	db $AA,$AA,$55,$55,$55,$55,$55,$55
;corner_top_right
;	db $A9,$A9,$57,$57,$57,$57,$57,$57
;edge_left
;	db $95,$95,$95,$95,$95,$95,$95,$95
;edge_right
;	db $57,$57,$57,$57,$57,$57,$57,$57
;corner_bottom_left
;	db $95,$95,$95,$95,$95,$95,$7F,$7F
;edge_bottom
;	db $55,$55,$55,$55,$55,$55,$FF,$FF
;corner_bottom_right
;	db $57,$57,$57,$57,$57,$57,$FF,$FF

restore_window_1
	ldx #MENU_X+5
	ldy #MENU_Y+5
	;
	lda #MENU_WIDTH-12
	sta wwidth
	lda #0
	sta wheight
	;
	jmp restore_window

restore_window_2
	ldx #MENU_X+4
	ldy #MENU_Y+4
	;
	lda #MENU_WIDTH-10
	sta wwidth
	lda #MENU_HEIGHT-10
	sta wheight
	;
	jmp restore_window

restore_window_3
	ldx #MENU_X+3
	ldy #MENU_Y+3
	;
	lda #MENU_WIDTH-8
	sta wwidth
	lda #MENU_HEIGHT-8
	sta wheight
	;
	jmp restore_window

restore_window_4
	ldx #MENU_X+2
	ldy #MENU_Y+2
	;
	lda #MENU_WIDTH-6
	sta wwidth
	lda #MENU_HEIGHT-6
	sta wheight
	;
	jmp restore_window

restore_window_5
	ldx #MENU_X+1
	ldy #MENU_Y+1
	;
	lda #MENU_WIDTH-4
	sta wwidth
	lda #MENU_HEIGHT-4
	sta wheight
	;
	jmp restore_window

restore_window_6
	ldx #MENU_X
	ldy #MENU_Y
	;
	lda #MENU_WIDTH-2
	sta wwidth
	lda #MENU_HEIGHT-2
	sta wheight
	;
restore_window
	jsr w_calc_pos
	;
	lda w_lum_dst				; set lum/col source
	sta w_lum_src
	lda w_lum_dst+1
	clc
	adc #$28				; fixed $2800 away from dest
	sta w_lum_src+1
	;
	lda w_col_dst
	sta w_col_src
	lda w_col_dst+1
	clc
	adc #$28
	sta w_col_src+1
	;
	ldy wwidth				; restore colors
	iny
	iny
rw01	lda (w_lum_src),y			; top line
	sta (w_lum_dst),y
	lda (w_col_src),y
	sta (w_col_dst),y
	dey
	bpl rw01
	;
	lda w_lum_src
	clc
	adc #40
	sta w_lum_src
	sta w_lum_dst
	sta w_col_src
	sta w_col_dst
	bcc *+10
	inc w_lum_src+1
	inc w_lum_dst+1
	inc w_col_src+1
	inc w_col_dst+1
	;
	ldx wheight
	beq rw04
rw02	ldy wwidth
	iny
	iny
	lda (w_lum_src),y			; sides
	sta (w_lum_dst),y
	lda (w_col_src),y
	sta (w_col_dst),y
	ldy #$00
	lda (w_lum_src),y
	sta (w_lum_dst),y
	lda (w_col_src),y
	sta (w_col_dst),y
	;
	lda w_lum_src
	clc
	adc #40
	sta w_lum_src
	sta w_lum_dst
	sta w_col_src
	sta w_col_dst
	bcc *+10
	inc w_lum_src+1
	inc w_lum_dst+1
	inc w_col_src+1
	inc w_col_dst+1
	;
	dex
	bne rw02
	;
rw04	ldy wwidth
	iny
	iny
rw03	lda (w_lum_src),y			; bottom line
	sta (w_lum_dst),y
	lda (w_col_src),y
	sta (w_col_dst),y
	dey
	bpl rw03
	;
	; ---
	;
	lda w_bitmap_dst
	sta w_bitmap_src
	lda w_bitmap_dst+1
	clc
	adc #$28
	sta w_bitmap_src+1
	;
	lda wwidth
	asl a
	asl a 
	asl a
	clc
	adc #$17
	sta w_max_y
	tay
rw10	lda (w_bitmap_src),y
	sta (w_bitmap_dst),y
	dey
	bne rw10				; stop at 0
	lda (w_bitmap_src),y			; but the 0th byte have not been copied,
	sta (w_bitmap_dst),y			; so copy that too
	;
	lda w_bitmap_src
	clc
	adc #$40
	sta w_bitmap_src
	lda w_bitmap_src+1
	adc #$01
	sta w_bitmap_src+1
	;
	lda w_bitmap_dst
	clc
	adc #$40
	sta w_bitmap_dst
	lda w_bitmap_dst+1
	adc #$01
	sta w_bitmap_dst+1
	;
	ldx wheight
	beq rw14 
rw11	ldy w_max_y
	lda (w_bitmap_src),y			; right side (no loop)
	sta (w_bitmap_dst),y
	dey	
	lda (w_bitmap_src),y
	sta (w_bitmap_dst),y
	dey
	lda (w_bitmap_src),y
	sta (w_bitmap_dst),y
	dey
	lda (w_bitmap_src),y
	sta (w_bitmap_dst),y
	dey
	lda (w_bitmap_src),y
	sta (w_bitmap_dst),y
	dey	
	lda (w_bitmap_src),y
	sta (w_bitmap_dst),y
	dey
	lda (w_bitmap_src),y
	sta (w_bitmap_dst),y
	dey
	lda (w_bitmap_src),y
	sta (w_bitmap_dst),y
	;
	ldy #$07
rw12	lda (w_bitmap_src),y
	sta (w_bitmap_dst),y
	dey
	bpl rw12
	;
	lda w_bitmap_src
	clc
	adc #$40
	sta w_bitmap_src
	lda w_bitmap_src+1
	adc #$01
	sta w_bitmap_src+1
	;
	lda w_bitmap_dst
	clc
	adc #$40
	sta w_bitmap_dst
	lda w_bitmap_dst+1
	adc #$01
	sta w_bitmap_dst+1
	;
	dex
	bne rw11
	;
rw14	ldy w_max_y
rw13	lda (w_bitmap_src),y
	sta (w_bitmap_dst),y
	dey
	bne rw13				; stop at 0
	lda (w_bitmap_src),y			; but the 0th byte have not been copied,
	sta (w_bitmap_dst),y			; so copy that too
	;
	rts
	
mul40_lo
	db 0 * 40 & 255
	db 1 * 40 & 255
	db 2 * 40 & 255
	db 3 * 40 & 255
	db 4 * 40 & 255
	db 5 * 40 & 255
	db 6 * 40 & 255
	db 7 * 40 & 255
	db 8 * 40 & 255
	db 9 * 40 & 255
	db 10 * 40 & 255
	db 11 * 40 & 255
	db 12 * 40 & 255
	db 13 * 40 & 255
	db 14 * 40 & 255
	db 15 * 40 & 255
	db 16 * 40 & 255
	db 17 * 40 & 255
	db 18 * 40 & 255
	db 19 * 40 & 255
	db 20 * 40 & 255
	db 21 * 40 & 255
	db 22 * 40 & 255
	db 23 * 40 & 255
	db 24 * 40 & 255
mul40_hi
	db 0 * 40 >> 8
	db 1 * 40 >> 8
	db 2 * 40 >> 8
	db 3 * 40 >> 8
	db 4 * 40 >> 8
	db 5 * 40 >> 8
	db 6 * 40 >> 8
	db 7 * 40 >> 8
	db 8 * 40 >> 8
	db 9 * 40 >> 8
	db 10 * 40 >> 8
	db 11 * 40 >> 8
	db 12 * 40 >> 8
	db 13 * 40 >> 8
	db 14 * 40 >> 8
	db 15 * 40 >> 8
	db 16 * 40 >> 8
	db 17 * 40 >> 8
	db 18 * 40 >> 8
	db 19 * 40 >> 8
	db 20 * 40 >> 8
	db 21 * 40 >> 8
	db 22 * 40 >> 8
	db 23 * 40 >> 8
	db 24 * 40 >> 8

mul320_lo
	db BITMAP + 0 * 320 & 255
	db BITMAP + 1 * 320 & 255
	db BITMAP + 2 * 320 & 255
	db BITMAP + 3 * 320 & 255
	db BITMAP + 4 * 320 & 255
	db BITMAP + 5 * 320 & 255
	db BITMAP + 6 * 320 & 255
	db BITMAP + 7 * 320 & 255
	db BITMAP + 8 * 320 & 255
	db BITMAP + 9 * 320 & 255
	db BITMAP + 10 * 320 & 255
	db BITMAP + 11 * 320 & 255
	db BITMAP + 12 * 320 & 255
	db BITMAP + 13 * 320 & 255
	db BITMAP + 14 * 320 & 255
	db BITMAP + 15 * 320 & 255
	db BITMAP + 16 * 320 & 255
	db BITMAP + 17 * 320 & 255
	db BITMAP + 18 * 320 & 255
	db BITMAP + 19 * 320 & 255
	db BITMAP + 20 * 320 & 255
	db BITMAP + 21 * 320 & 255
	db BITMAP + 22 * 320 & 255
	db BITMAP + 23 * 320 & 255
	db BITMAP + 24 * 320 & 255
mul320_hi
	db BITMAP + 0 * 320 >> 8
	db BITMAP + 1 * 320 >> 8
	db BITMAP + 2 * 320 >> 8
	db BITMAP + 3 * 320 >> 8
	db BITMAP + 4 * 320 >> 8
	db BITMAP + 5 * 320 >> 8
	db BITMAP + 6 * 320 >> 8
	db BITMAP + 7 * 320 >> 8
	db BITMAP + 8 * 320 >> 8
	db BITMAP + 9 * 320 >> 8
	db BITMAP + 10 * 320 >> 8
	db BITMAP + 11 * 320 >> 8
	db BITMAP + 12 * 320 >> 8
	db BITMAP + 13 * 320 >> 8
	db BITMAP + 14 * 320 >> 8
	db BITMAP + 15 * 320 >> 8
	db BITMAP + 16 * 320 >> 8
	db BITMAP + 17 * 320 >> 8
	db BITMAP + 18 * 320 >> 8
	db BITMAP + 19 * 320 >> 8
	db BITMAP + 20 * 320 >> 8
	db BITMAP + 21 * 320 >> 8
	db BITMAP + 22 * 320 >> 8
	db BITMAP + 23 * 320 >> 8
	db BITMAP + 24 * 320 >> 8
;eof